package com.lyg.application.util;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lyg.application.entity.TaIncompatible;
import com.lyg.application.entity.TaRotation;
import com.lyg.application.mapper.TaIncompatibleMapper;
import com.lyg.application.mapper.TaRotationMapper;
import com.lyg.application.service.TaIncompatibleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Component
public class Rule {

    @Autowired
    TaIncompatibleService taIncompatibleService;


    @Autowired
    TaIncompatibleMapper taIncompatibleMapper;
    @Autowired
    TaRotationMapper taRotationMapper;

    public List<TaIncompatible> regularRules(String primaryPost, String targetPost) {
        return taIncompatibleService.getRegularRules(primaryPost, targetPost);

    }


    public List<TaRotation> getMonthRules(Map<String, String> params) {
        List<TaRotation> repelList = new ArrayList<>();

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        QueryWrapper<TaRotation> queryWrapper = new QueryWrapper<>();
        String primaryPost = params.get("primaryPost");
        String targetPost = params.get("targetPost");
        String passTime = params.get("passTime");
        LocalDate newDate = LocalDate.parse(passTime, formatter).minusMonths(3);

        List<String> oldPostList = taIncompatibleMapper.getMonthRulesPrimary(primaryPost);//原来岗位+目标不相容岗位
        List<String> newPostList = taIncompatibleMapper.getMonthRulesTarget(targetPost);//目标岗位+原来不相容岗位

        if (oldPostList.size() == 0 && newPostList.size() == 0) {
            return repelList;
        } else {
            List<String> orgList = newPostList;//原来岗位 不相容的
            orgList.add(orgList.size() - 1, primaryPost);

            List<String> targetList = oldPostList;//目标岗位 不相容的
            targetList.add(targetList.size() - 1, targetPost);

            //                拿到数据 不相容轮岗数据
            repelList = taRotationMapper.selectRepel(orgList, targetList, newDate);

            return repelList;
        }
    }
}
